#ifndef __POWER_TEMLPATE
#define __POWER_TEMLPATE

namespace power_template
{
		template <class _Arg1, class _Arg2, class _Result>
		struct binary_function {
		  typedef _Arg1 first_argument_type;
		  typedef _Arg2 second_argument_type;
		  typedef _Result result_type;
		#if !defined (__BORLANDC__) || (__BORLANDC__ < 0x580)
		protected:
		  /* See unary_function comment. */
		  ~binary_function() {}
		#endif
		};

		template <class _Tp>
		struct multiplies : public binary_function<_Tp, _Tp, _Tp> {
		  _Tp operator()(const _Tp& __x, const _Tp& __y) const { return __x * __y; }
		};
		 
		template <class _Tp> inline _Tp identity_element(multiplies<_Tp>) {
		  return _Tp(1);
		};

		template <class _Tp, class _Integer, class _MonoidOperation>
		_Tp __power(_Tp __x, _Integer __n, _MonoidOperation __opr)
		{
		  if (__n == 0)
			return identity_element(__opr);
		  else {
			while ((__n & 1) == 0) {
			  __n >>= 1;
			  __x = __opr(__x, __x);
			}

			_Tp __result = __x;
			__n >>= 1;
			while (__n != 0) {
			  __x = __opr(__x, __x);
			  if ((__n & 1) != 0)
				__result = __opr(__result, __x);
			  __n >>= 1;
			}
			return __result;
		  }
		}

		template <class _Tp, class _Integer>
		inline _Tp __power(_Tp __x, _Integer __n)
		{
		  return __power(__x, __n, multiplies<_Tp>());
		}

		// Alias for the internal name __power.  Note that power is an extension,
		// not part of the C++ standard.

		template <class _Tp, class _Integer, class _MonoidOperation>
		inline _Tp power(_Tp __x, _Integer __n, _MonoidOperation __opr)
		{
		  return __power(__x, __n, __opr);
		}

		template <class _Tp, class _Integer>
		inline _Tp power(_Tp __x, _Integer __n)
		{
		  return __power(__x, __n);
		}
}

#endif